#include <stdio.h>
#include "pxhan.h"
#define UNIT_MOVE	16		/* for speed up */

#ifdef _MEMMOVE
void
memmove(char *dst, char *src, int n)
{
	int  i, div, remain;

	div = n / UNIT_MOVE;
	remain = n % UNIT_MOVE;
	for(i = 0; i < div; i++) {
		*dst++ = *src++; *dst++ = *src++; *dst++ = *src++; *dst++ = *src++;
		*dst++ = *src++; *dst++ = *src++; *dst++ = *src++; *dst++ = *src++;
		*dst++ = *src++; *dst++ = *src++; *dst++ = *src++; *dst++ = *src++;
		*dst++ = *src++; *dst++ = *src++; *dst++ = *src++; *dst++ = *src++;
	}
	for(i = 0; i < remain; i++)
		*dst++ = *src++;
}
#endif /* _MEMMOVE */

char  VXByteOrder;

void
VXCheckSystemByteOrder()
{
	short  val = 0x1234;
	char  *ptr;

	ptr = (char *) &val;
	if(*ptr == 0x12) {
		VXByteOrder = OP_MSB_FIRST;
		puts("Byte order of this system     is MSB First");
	} else {
		VXByteOrder = OP_LSB_FIRST;
		puts("Byte order of this system     is LSB First");
	}
}

short
VXMemShort(Channel *ch, char *ptr, int offset)
{
	char  buf[2];
	short  *sptr;

	if(ch->byte_order == VXByteOrder) {
		sptr = (short *) (ptr+offset);
	} else {
		buf[1] = ptr[offset];
		buf[0] = ptr[offset+1];
		sptr = (short *)buf;
	}
	return  *sptr;
}

long
VXMemLong(Channel *ch, char *ptr, int offset)
{
	char  buf[4];
	long  *lptr;

	if(ch->byte_order == VXByteOrder) {
		lptr = (long *) (ptr+offset);
	} else {
		buf[0] = ptr[offset+3];
		buf[1] = ptr[offset+2];
		buf[2] = ptr[offset+1];
		buf[3] = ptr[offset];
		lptr = (long *) buf;
	}
	return  *lptr;
}

long
VXMemMSBLong(char *ptr, int offset)
{
	char  buf[4];
	long  *lptr;

	if(VXByteOrder == OP_MSB_FIRST) {
		lptr = (long *) (ptr+offset);
	} else {
		buf[0] = ptr[offset+3];
		buf[1] = ptr[offset+2];
		buf[2] = ptr[offset+1];
		buf[3] = ptr[offset];
		lptr = (long *) buf;
	}
	return  *lptr;
}

void
VXSetMemMSBShort(char *ptr, int offset, short val)
{
	ptr[offset]   = (val & 0xff00) >> 8;
	ptr[offset+1] = (val & 0x00ff);
}

void
VXSetMemLSBShort(char *ptr, int offset, short val)
{
	ptr[offset+1] = (val & 0xff00) >> 8;
	ptr[offset]   = (val & 0x00ff);
}

void
VXSetMemMSBLong(char *ptr, int offset, long val)
{
	ptr[offset]   = (val & 0xff000000) >> 24;
	ptr[offset+1] = (val & 0x00ff0000) >> 16;
	ptr[offset+2] = (val & 0x0000ff00) >> 8;
	ptr[offset+3] = (val & 0x000000ff);
}

void
VXSetMemLSBLong(char *ptr, int offset, long val)
{
	ptr[offset+3] = (val & 0xff000000) >> 24;
	ptr[offset+2] = (val & 0x00ff0000) >> 16;
	ptr[offset+1] = (val & 0x0000ff00) >> 8;
	ptr[offset]   = (val & 0x000000ff);
}
